#ifndef TESTSINK_H
#define TESTSINK_H

#include <QtCore>
#include <QImage>
#include <mbarcode-qt/plugininterfaces.h>
#include <mbarcode-qt/pluginaction.h>

class QrSink : public PluginAction
{
    Q_OBJECT
public:
    enum barcodeType {
        Unknown=0,
        Email,
        URL,
        SMS,
        MMS,
        PhoneNumber,
        vCard,
        BizCard,
        iMode,
        iModeMECARD,
        Geo,
        YouTube,
        Install,
        Ovi,
        iCal,
        Apt
    };
    // inherited virtuals
    QrSink(const PluginInterface *interface);
    QString getName() {return "QR-code sink plugin";}
    QString getText();
    QImage getImage();
    QString getInformativeText();
    void clickAction(QWidget *parentWindow);
    // other
    //QString url;
signals:
    void isReady();
private slots:
    void barcodeAnalysed(QString barcodeType, QString barcodeData);
private:
    void openGeneric(QString uri);
    void addVCard(QString user_data);
    void addiCal(QString user_data);
    void openInstallFile(QString data);
    void openBrowser(QString uri);
    void addMECARD(QString user_data);
    void openGeo(QString data);
    void openApt(QString data);

    QString buttonText;
    QString barcodeText;
    QString barcodeInformativeText;
    int type;

    QImage image;
};

#endif // TESTSINK_H
